#!/bin/sh

name=dunemdb_supplier_online_movies

mydir=`dirname "$0"`
mydir=`cd "$mydir" && pwd`
basedir=`cd "$mydir/.." && pwd`

tmp_dir="$FS_PREFIX/tmp/plugins/$name"
chmod 777 "$tmp_dir"

dpath="$FS_PREFIX/flashdata/plugins_data/$name/movie_suppliers"
mkdir -p "$dpath"

cgi="$FS_PREFIX/firmware_ext/php/php-cgi"
run_cmd="$cgi -c $mydir -f ./run.php"

###########################################################################

id="online_movies"
caption="%tr%title_supplier"

play_action="\
{\
  \\\"handler_string_id\\\":\\\"plugin_handle_user_input\\\",\
  \\\"params\\\": { \\\"handler_id\\\":\\\"entry\\\", \\\"control_id\\\":\\\"play\\\" },\
  \\\"plugin_name\\\":\\\"$name\\\"\
}"

path="$dpath/$id"
cat << EOF >"$path"
{
  "plugin" : "$name",
  "caption" : "$caption",
  "special_category_caption" : "%tr%title_short",
  "langs" : "any",
  "bin" : "cd $mydir && $run_cmd",
  "base_path" : "$basedir",
  "playback_type" : "stream_special",
  "play_action" : "$play_action"
}
EOF

###########################################################################

id="online_movies_manual"
caption="%tr%title_supplier_manual"

play_action="\
{\
  \\\"handler_string_id\\\":\\\"plugin_handle_user_input\\\",\
  \\\"params\\\": { \\\"handler_id\\\":\\\"entry\\\", \\\"control_id\\\":\\\"play\\\", \\\"manual\\\":\\\"1\\\" },\
  \\\"plugin_name\\\":\\\"$name\\\"\
}"

path="$dpath/$id"
cat << EOF >"$path"
{
  "plugin" : "$name",
  "caption" : "$caption",
  "special_category_caption" : "%tr%title_short",
  "langs" : "any",
  "bin" : "cd $mydir && $run_cmd",
  "base_path" : "$basedir",
  "playback_type" : "stream_special",
  "play_action" : "$play_action"
}
EOF
