#!/bin/sh

mydir=`dirname "$0"`
mydir=`cd "$mydir" && pwd`
basedir=`cd "$mydir/.." && pwd`

dirpath="$FS_PREFIX/tmp/movie_suppliers"

php="$FS_PREFIX/firmware_ext/php/php-cgi"

[ -e "$dirpath" ] || mkdir "$dirpath"

if [ -f "$FS_PREFIX/config/online_movies_full.txt" ]; then
  with_auto=$(cat "$FS_PREFIX/config/online_movies_full.txt")
else
  with_auto=1
fi

if [ "$with_auto" = "1" ]; then
  filepath="$dirpath/online_movies"

  play_action="\
  {\
    \\\"handler_string_id\\\":\\\"plugin_handle_user_input\\\",\
    \\\"params\\\": { \\\"handler_id\\\":\\\"entry\\\", \\\"control_id\\\":\\\"play\\\" },\
    \\\"plugin_name\\\":\\\"dunemdb_supplier_online_movies\\\"\
  }"

  cat << EOF > "$filepath"
  {
    "plugin" : "dunemdb_supplier_online_movies",
    "caption" : "%tr%title_supplier",
    "special_category_caption" : "%tr%title_short",
    "langs" : "any",
    "bin" : "$php -c $mydir -f $mydir/run.php",
    "base_path" : "$basedir",
    "playback_type" : "stream_special",
    "play_action" : "$play_action"
  }
EOF
fi

filepath="$dirpath/online_movies_manual"

play_action="\
{\
  \\\"handler_string_id\\\":\\\"plugin_handle_user_input\\\",\
  \\\"params\\\": { \\\"handler_id\\\":\\\"entry\\\", \\\"control_id\\\":\\\"play\\\", \\\"manual\\\":\\\"1\\\" },\
  \\\"plugin_name\\\":\\\"dunemdb_supplier_online_movies\\\"\
}"

[ "$with_auto" = 1 ] && \
  t_key="title_supplier_manual" || \
  t_key="title_supplier_common"

cat << EOF > "$filepath"
{
  "plugin" : "dunemdb_supplier_online_movies",
  "caption" : "%tr%$t_key",
  "special_category_caption" : "%tr%title_short",
  "langs" : "any",
  "bin" : "$php -c $mydir -f $mydir/run.php",
  "base_path" : "$basedir",
  "playback_type" : "stream_special",
  "play_action" : "$play_action"
}
EOF
