<?php

require_once 'ext/ext_helper.php';

class TorrServer
{
    static $PORT = 8095;

	static $torrServIp = null;
	static $torrServItems = null;

	public static function getIp (){
        if (null === self::$torrServIp){
            $torrservIp = getenv("TORRSERV_IP");
            if (class_exists('MainHelper'))
            {
                if (!$torrservIp)
                    $torrservIp = MainHelper::$settings->ext_torrserver;
            }
            if ($torrservIp && 0 !== strpos($torrservIp, 'http'))
                $torrservIp = "http://$torrservIp";
            if (!$torrservIp)
                $torrservIp = "http://127.0.0.1:" . self::$PORT;
            hd_print("Using TorrServer IP: $torrservIp");
            self::$torrServIp = $torrservIp;
        }
        return self::$torrServIp;
    }

    public static function unsetIp()
    {
        self::$torrServIp = null;
    }

	public static function torrserverAddTorrent($path, $torrServAction){
		$tmp = explode ('.', HD::get_ip_address());
		$dontSave = false;
		if ($torrServAction == 1)
			$dontSave = true;
		if ((!preg_match("|".$tmp[0]."|", self::getIp()))&&
			(!preg_match("|magnet:\?xt=|",$path))&&
			(!preg_match("|127\.0\.0\.1|", self::getIp()))
		)
			$hash = self::torrserverActionUpload('/tmp/www/temp.torrent', $dontSave);
		else{
			$hash = self::torrserverActionAdd($path, null, $dontSave);
		}
		return $hash;
	}
	
	public static function getStatusTorrServer (){
		$torrServIp = self::getIp();
		if ($torrServIp != ''){
			$cmd = HD::isDomainAvailible("$torrServIp/echo");
			if($cmd == true)
				return $cmd;
		}
		return false;
	}
	public static function getOnlineStatusServer (){
		$torrServIp = self::getIp();
		if ($torrServIp != ''){
			if (HD::isServerAvailable($torrServIp) == true)
				return true;
		}
		return false;
	}
	public static function torrserverActionUpload($first_arg, $dontSave=null){
		$arr['file'] = '@' . $first_arg;
		if ($dontSave == false)
			$arr['save'] = true;
		$jsd = json_decode(HD::http_post_document(self::getIp() . '/torrent/upload', $arr));
		if (($jsd == false)||(!isset($jsd->hash)))
			return false;
		return $jsd->hash;
	}
	public static function torrserverActionSettingsWrite($arr){
		$arr["action"]="set";
		$arr["sets"]= $arr;
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($arr)
				)
			)
		);
		$response =  file_get_contents(self::getIp() . '/settings', 0, $context);
		return true;
	}
	public static function torrserverActionSettingsRead(){
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> '{"action":"get"}'
				)
			)
		);
		$response = file_get_contents(self::getIp() . '/settings',0,$context);
		if ($response == true){
			$jsd = json_decode($response);
			if (json_last_error() === JSON_ERROR_NONE)
				return $jsd;
		}
		return false;
	}
	public static function actionGetTorrentListAsync(){
		// $str = HD::do_cmd('run', 'action=torrentTorrServList torrServIp=' . self::getIp());
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/run.php action=torrentTorrServList torrServIp=" . self::getIp ();
		$str = HD::asyncExec($cmdAsyncExec);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function torrserverActionListTorrents(){
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> '{"action":"list"}'
				)
			)
		);
		$response = file_get_contents(self::getIp() . '/torrents',0,$context);
		if ($response == true){
			$jsd = json_decode($response);
			if (json_last_error() === JSON_ERROR_NONE)
				return $jsd;
		}
		return false;
	}
    public static function getTorrentListRequestCtx() {
        $ip = self::getIp();
        return (object) array(
            'url' => $ip . '/torrents',
            'post_data' => '{"action":"list"}',
            'timeout' => 1,
        );
    }
	public static function torrserverActionDrop($hash){
		$arr["action"]="drop";
		$arr["hash"]= $hash;
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($arr)
				)
			)
		);
		$jsd = json_decode(file_get_contents(self::getIp() . '/torrents', 0, $context));
		return true;
	}
	public static function torrserverActionRem($hash){
		
		$arr["action"]="rem";
		$arr["hash"]= $hash;
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($arr)
				)
			)
		);
		$jsd = json_decode(file_get_contents(self::getIp() . '/torrents', 0, $context));
		return true;
	}
	public static function torrserverActionAdd($first_arg, $infoArr = null, $dontSave = null){
		$addTorrServInf = (HD::getItemStr('addTorrServInf', true) !='') ? HD::getItemStr('addTorrServInf', true) : 0;
		$content["action"] = "add";
		$content["link"] = $first_arg;
		if (($infoArr==true)&&($addTorrServInf == 1)){
			$content["title"] = $infoArr["title"];
			$content["poster"] = $infoArr["poster_path"];
		}
		$content["save_to_db"] = true;
		if ($dontSave==true)
			$content["save_to_db"] = false;
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($content)
				)
			)
		);
hd_print("EEE ADD: ".print_r($content,1));
		$jsd = json_decode(file_get_contents(self::getIp() . '/torrents', 0, $context));
		if (isset($jsd->hash))
				return $jsd->hash;
		return false;
	}
	public static function torrserverActionGet($hash){
		$arr["action"] = "get";
		$arr["hash"] = $hash;
		$context = stream_context_create(
			array(
				'http' => array(
					'timeout' => 1,
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode ($arr)
				)
			)
		);
		hd_silence_warnings();
		$str = file_get_contents(self::getIp() . '/torrents', 0, $context);
		hd_restore_warnings();
		if ($str == true){
			$str = preg_replace('/("\w+"):\s*?(\d+),/', '\\1:"\\2",', $str);
			$str = preg_replace('/("length"):\s*?(\d+)/', '\\1:"\\2"', $str);
			return json_decode ($str);
		}
		return false;
	}
	public static function torrserverActionViewed($first_arg){
		$context = stream_context_create(
			array(
				'http' => array(
					'timeout' => 1,
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> '{"action":"list", "hash":"'.$first_arg.'"}'
				)
			)
		);
		hd_silence_warnings();
		$response = file_get_contents(self::getIp() . '/viewed', 0, $context);
		hd_restore_warnings();
		if ($response == true){
			$str = preg_replace('/("\w+"):\s*?(\d+)/', '\\1:"\\2"', $response);
			return json_decode ($str);
		}
		return false;
	}
	public static function torrserverActionStop(){
		hd_silence_warnings();
		file_get_contents(self::getIp() . '/shutdown');
		hd_restore_warnings();
		sleep (2);
		return self::getStatusTorrServer();
	}
	public static function torrserverActionPreload($first_arg){
		exec('wget --quiet -O - "'. str_replace('&play', '&preload', $first_arg) .'" > /dev/null &');
		return true;
	}
    public static function do_get_series_list($hash, $file_stats)
    {
        $items = array();
        foreach ($file_stats as $key => $vel){
            $pathinfo = pathinfo($vel->path);
            $ext = HD::get($pathinfo, 'extension');
            if (!$ext)
                continue;
            if (!preg_match(
                    "/mp3|wav|og(?:g|a)|flac|dts|ac3|rm|aac|wma|mka|ape|".
                    "mpeg|ra?m|avi|mp(?:g|e|4)|mov|divx|asf|qt|wmv|m\dv|".
                    "rv|vob|asx|ogm|mkv|m2ts|ts/i", $ext))
            {
                continue;
            }
            $title = pathinfo($vel->path, PATHINFO_BASENAME);

            $items[$vel->path] = array();
            $item = &$items[$vel->path];

            $item['title'] = $title;
            $item['id'] = md5 ($vel->path);//to be continue
            if (isset($vel->length))
            {
                $item['size'] = HD::readableBytes($vel->length);
                $item['size_mb'] = ExtHelper::size_to_mb($item['size']);
            }
            $item['playback_url'] = self::getIp() . '/stream/' .
                str_replace(' ', '%20', $title) .
                '?link=' . $hash . '&index=' . $vel->id . '&play';
        }
        ksort($items);
        return $items;
    }
}
?>
