<?php

require_once 'properties.php';

class ConfigUtils
{
    public static function load_location_info()
    {
        $country = "";
        $city = "";

        $location_info_path = null;
        if (is_file("/tmp/location_info.properties"))
            $location_info_path = "/tmp/location_info.properties";
        else if (is_file("/config/location_info.properties"))
            $location_info_path = "/config/location_info.properties";

        if (isset($location_info_path))
        {
            $lines = file($location_info_path,
                FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
            foreach ($lines as $line)
            {
                $pos = strpos($line, " = ");
                if ($pos === false)
                    continue;

                $key = substr($line, 0, $pos);
                $val = trim(substr($line, $pos + 3));
                if ($key == 'country')
                    $country = $val;
                else if ($key == 'city')
                    $city = $val;
            }
        }

        return (object) array(
            'country' => $country,
            'city' => $city
        );
    }
}

?>
