<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';

require_once 'lib/config_utils.php';

require_once 'lib/vod/movie.php';

require_once 'ext/TorrServer.php';
require_once 'ext/TorLook_Class.php';

require_once 'tordb/TorLookDB.php';
require_once 'tordb/JacketDB.php';

require_once 'main_helper.php';
require_once 'lang_helper.php';
require_once 'url_helper.php';
require_once 'storage_helper.php';
require_once 'state.php';
require_once 'dl_state.php';
require_once 'config.php';
require_once 'settings.php';
require_once 'model.php';
require_once 'playback.php';
require_once 'pb_stat.php';
require_once 'progress_dialog.php';
require_once 'switch_dialog.php';
require_once 'torrent_helper.php';
require_once 'movie_torrents.php';
require_once 'torrent_files.php';
require_once 'torrent_history.php';
require_once 'main_entry_handler.php';
require_once 'seasons_screen.php';
require_once 'torrents_screen.php';
require_once 'torrent_files_screen.php';
require_once 'add_torrent_dialog.php';
require_once 'setup_screen.php';

///////////////////////////////////////////////////////////////////////////

class MainPlugin extends DefaultDunePlugin
{
    public function __construct()
    {
        MainHelper::$plugin = $this;

        MainHelper::$config = new Config();
        MainHelper::$storage_helper = new StorageHelper();
        MainHelper::$settings = new Settings();

        MainHelper::$entry_handler = new MainEntryHandler();

        MainHelper::$dl_state = new DlState();

        MainHelper::$progress = new ProgressDialog("progress_dialog");

        MainHelper::$model = new Model();
        MainHelper::$pb_stat = new PBStat();
        MainHelper::$playback = new Playback();
        MainHelper::$switch_dialog = new SwitchDialog();
        MainHelper::$torrent_history = new TorrentHistory();
        MainHelper::$model = new Model();

        MainHelper::$seasons_screen = new SeasonsScreen();
        MainHelper::$torrents_screen = new TorrentsScreen();
        MainHelper::$torrent_files_screen = new TorrentFilesScreen();
        MainHelper::$add_torrent_dialog = new AddTorrentDialog();
        MainHelper::$setup_screen = new SetupScreen();

        MainHelper::$state = new State();

        // TODO
        //MainHelper::$tordb = new TorLookDB();
        MainHelper::$tordb = new JacketDB();

        $this->add_screen(MainHelper::$seasons_screen);
        $this->add_screen(MainHelper::$torrents_screen);
        $this->add_screen(MainHelper::$torrent_files_screen);
        $this->add_screen(MainHelper::$setup_screen);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
