<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';
require_once 'lib/control_factory.php';

class SetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    public function __construct()
    {
        parent::__construct(self::ID);
    }

    private function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();

        $ss = MainHelper::$settings;
        $names = $ss->get_all_names();

        foreach ($names as $name)
        {
            $value = $ss->get_value($name);
            $label = $ss->get_ui_label($name);
            $opts = $ss->get_ui_opts($name);

            if (is_array($opts))
            {
                ControlFactory::add_combobox($defs, $this, null,
                    $name, $label, $value, $opts, 0, false, true);
            }
            else
            {
                ControlFactory::add_text_field($defs, $this, null,
                    $name, $label, $value,
                    false, false, false, true,
                    500, false, true,
                    array('text_field_apply_on_move' => 1));
            }
        }

        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Setup screen: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        $control_id = HD::get($user_input, 'control_id', 'none');

        $ss = MainHelper::$settings;

        if ($ss->is_setting_name($control_id))
        {
            $ss->set_value($control_id, $user_input->$control_id);
            return null;
        }

        return null;
    }
}
