<?php 
class TorrentInfo
{
    const DEBUG_INVALID = 0;

    ///////////////////////////////////////////////////////////////////////

    public $movie_names;
    public $movie_series;
    public $movie_first_year;
    public $movie_season_numbers;
    public $movie_sset;

    public $good;

    public $orig_name;
    public $size_mb;
    public $seeds;
    public $leeches;

    public $remove_movie_names;

    public $replaced_name;

    public $movie_name_year;
    public $name;
    public $years; // String like 2007,2011 or 2000 or 2011-2019
    public $tail;
    public $tags;
    public $bad_tags;
    public $other_res_tags;
    public $res_quality;
    public $quality;
    public $quality_str;
    public $seasons;
    public $single_episode;
    public $episodes; // object: from,to,total
    public $bonus;
    public $add_content;
    public $add_content_ndx; // TODO: revise, maybe use add_content_ndx
    public $left_brackets;
    public $se_str;
    public $invalid;
    public $name_or_year_invalid;
    public $flags;

    ///////////////////////////////////////////////////////////////////////

    private static $SEARCH_IREPLACE = array(
        '—' => '-',
        '–' => '-',
        'ё' => 'е',
        'Ё' => 'Е',
        'вdrip' => 'bdrip',
        'blurip' => 'bdrip',
        'brrip' => 'bdrip',
        'blu-ray' => 'bluray',
        'hdr10+' => 'hdr10plus',
        'dvd-5' => 'dvd5',
        'dvd-9' => 'dvd9',
        'dvd-10' => 'dvd10',
        'dvd-18' => 'dvd18',
        'hq1080' => 'hq 1080',
        '1080xh' => '1080p h',
    );
    private static $SEARCH = null;
    private static $IREPLACE = null;

    ///////////////////////////////////////////////////////////////////////

    private static $RPART_IGNORE = array(
        "аниме",
        "биография",
        "боевик",
        "вестерн",
        "военный",
        "детектив",
        "детский",
        "документальный",
        "драма",
        "игра",
        "исторический",
        "история",
        "комедия",
        "короткометражка",
        "криминал",
        "лгбт",
        "мелодрама",
        "музыка",
        "мультфильм",
        "мультсериал",
        "мюзикл",
        "приключения",
        "реальное",
        "реальное ТВ",
        "реалити-шоу",
        "семейный",
        "сказка",
        "спорт",
        "сэйнэн",
        "ток-шоу",
        "трагикомедия",
        "триллер",
        "ужасы",
        "фантастика",
        "фильм-нуар",
        "фэнтези",
        "экранизация",

        "аргентина",
        "австрия",
        "австралия",
        "бельгия",
        "болгария",
        "бразилия",
        "белоруссия",
        "канада",
        "швейцария",
        "китай",
        "чехия",
        "германия",
        "дания",
        "испания",
        "финляндия",
        "франция",
        "великобритания",
        "греция",
        "гонконг",
        "хорватия",
        "венгрия",
        "ирлания",
        "израиль",
        "индия",
        "ислания",
        "италия",
        "япония",
        "мексика",
        "нидерланды",
        "норвегия",
        "польша",
        "португалия",
        "румыния",
        "россия",
        "сербия",
        "швеция",
        "тайланд",
        "турция",
        "тайвань",
        "сша",
        "юар",
        "грузия",
        "армения",
        "азербайджан",
        "казахстан",
        "узбекистан",
        "украина",
        "молдова",
        "литва",
        "латвия",
        "эстония",
        "ссср",
    );
    private static $RPART_IGNORE_MAP = null;
    private static $RPART_IGNORE_MAP2 = array(
        "новая" => "зеландия",
        "мультипликационный" => "сериал",
        "историческая" => "драма",
    );

    ///////////////////////////////////////////////////////////////////////

    private static $TAG_JOIN = array(
        'web' => array(
            'dl' => 'webdl',
            'dlrip' => 'webrip',
            'rip' => 'webrip'),
        'webdl' => array(
            'rip' => 'webrip'),
        'blu' => array(
            'ray' => 'bluray',
            'rayremux' => 'bdremux'),
        'bluray' => array(
            'remux' => 'bdremux',
            'disc' => 'bluray',
            'custom' => 'bluraycustom',
            'rip' => 'bdrip',
            'dvd5' => 'dvdcustom',
            'dvd9' => 'dvdcustom',
            'dvd' => 'dvdcustom'),
        'bd' => array(
            'rip' => 'bdrip',
            'remux' => 'bdremux',
            'dvd5' => 'dvdcustom',
            'dvd9' => 'dvdcustom',
            'dvd' => 'dvdcustom'),
        'bdremux' => array(
            'dvd5' => 'dvdcustom',
            'dvd9' => 'dvdcustom',
            'dvd' => 'dvdcustom'),
        'dvd' => array(
            'r' => 'dvdr',
            'r9' => 'dvdr9',
            'rip' => 'dvdrip',
            'custom' => 'dvdcustom'),
        'dvd5' => array(
            'custom' => 'dvdcustom'),
        'dvd9' => array(
            'custom' => 'dvdcustom'),
        'dvdcustom' => array(
            'custom' => 'dvdcustom'),
        'hdtv' => array(
            'rip' => 'hdtvrip'),
        'hd' => array(
            'rip' => 'hdrip',
            'dvd' => 'hddvd'),
        'hddvd' => array(
            'rip' => 'hddvdrip',
            'remux' => 'hddvdremux'),

        'dolby' => array(
            'vision' => 'dv'),
        'dv' => array(
            'tv' => 'dv'),

        'h' => array(
            '265' => 'x265',
            '264' => 'x264'),
        'x' => array(
            '265' => 'x265',
            '264' => 'x264'),
        'mpeg' => array(
            '4' => 'mp4'),

        'ac' => array(
            '3' => 'ac3'),
        'dd5' => array(
            '1' => array('dd', '5.1'),
        ),
        'ddp5' => array(
            '1' => array('dd', '5.1'),
        ),
        'ddp7' => array(
            '1' => array('dd', '7.1'),
        ),

        'dts' => array(
            'es' => 'dtses',
            'hd' => 'dtshd',
            'hdma' => 'dtshd'),
        'dtshd' => array(
            'ma' => 'dtshd'),

        '5' => array(
            '1' => '5.1',),
        '7' => array(
            '1' => '7.1',),
        '2' => array(
            '0' => '2.0',),

        'дополнительные' => array(
            'материалы' => 'бонус'),
        'additional' => array(
            'materials' => 'бонус'),
        'бонус' => array(
            'диск' => 'бонус'),
        'bonus' => array(
            'disc' => 'bonus'),

        'первый' => array(
            'сезон' => 'season1'),
        'второй' => array(
            'сезон' => 'season2'),
        'третий' => array(
            'сезон' => 'season3'),
    );

    private static $TAG_REPL = array(
        'web' => 'webdl',
        'webdlrip' => 'webrip',
        'remux' => 'bdremux',
        'blurayrip' => 'bdrip',
        'dvdrrip' => 'dvdrip',
        '4к' => '2160p',
        '4k' => '2160p',
        '2160' => '2160p',
        '2к' => '1440p',
        '2k' => '1440p',
        '1440' => '1440p',
        '1080' => '1080p',
        '1920x1080' => '1080p',
        '720' => '720p',
        'm720p' => '720p',
        '1280x' => '720p',
        '1280x720' => '720p',
        'eac3' => 'ddp',

        'бонусы' => 'бонус',
    );

    private static $KNOWN_TAGS = array(
        '2160p' => '2160p',
        '1440p' => '1440p',
        '1080p' => '1080p',
        '1080i' => '1080i',
        '720p' => '720p',
        'sd' => 'SD',

        'bluray' => 'BluRay',
        'bluraycustom' => 'BluRay.Custom',
        'bdremux' => 'BDRemux',
        'hddvd' => 'HDDVD',
        'hddvdremux' => 'HDDVDRemux',
        'hdtv' => 'HDTV',
        'bdrip' => 'BDRip',
        'hddvdrip' => 'HDDVDRip',
        'webdl' => 'WebDl',
        'webrip' => 'WebRip',
        'hdtvrip' => 'HDTVRip',
        'hdrip' => 'HDRip',
        'dvdrip' => 'DVDRip',
        'dvd' => 'DVD',
        'dvd5' => 'DVD',
        'dvd9' => 'DVD',
        'dvd10' => 'DVD',
        'dvd18' => 'DVD',
        'dvdr' => 'DVD',
        'dvdr9' => 'DVD',
        'dvdcustom' => 'DVD.Custom',

        'dv' => 'DV',
        'hdr10plus' => 'HDR10+',
        'hdr10' => 'HDR',
        'hdr' => 'HDR',
    );

    private static $KNOWN_OTHER_TAGS = array(
        'hevc' => 'HEVC',
        'x265' => 'HEVC',
        'h265' => 'HEVC',
        'x264' => 'X264',
        'h264' => 'X264',
        'avc' => 'AVC',
        'avi' => 'AVI',
        'mp4' => 'MP4',
        'mpeg' => 'MPEG',
        'xvid' => 'XVID',
        'mkv' => 'mkv',
        'av1' => 'AV1',

#        'pal' => 'PAL',
#        'NTSC' => 'NTSC',
        '10bit' => '10bit',
        'ct' => 'CT',
        'uhd' => 'UHD',

        'ddp' => 'DDP',
        'dd' => 'AC3',
        'ac3' => 'AC3',
        'dtses' => 'DTS-ES',
        'dtsx' => 'DTS:X',
        'dtshd' => 'DTS-HD MA',
        'aac' => 'AAC',
        'truehd' => 'TrueHD',
        'atmos' => 'Atmos',
        '5.1' => '5.1',
        '7.1' => '7.1',
        '2.0' => '2.0',
    );

    private static $KNOWN_TAGS_ORDER = null;

    private static $BAD_TAGS = array(
        'pdf' => 1,
        'djvu' => 1,
        'fb2' => 1,
        'epub' => 1,
    );

    ///////////////////////////////////////////////////////////////////////

    const QRES_2160P        = 700;
    const QRES_1440P        = 600;
    const QRES_1080P        = 500;
    const QRES_1080I        = 400;
    const QRES_720P         = 300;
    const QRES_RIP          = 200;
    const QRES_SD           = 100;

    const QTYPE_BLURAY      = 90;
    const QTYPE_HDDVD       = 80;
    const QTYPE_BDRIP       = 70;
    const QTYPE_HDDVDRIP    = 60;
    const QTYPE_WEBDL       = 50;
    const QTYPE_HDTV        = 40;
    const QTYPE_WEBRIP      = 30;
    const QTYPE_HDTVRIP     = 20;
    const QTYPE_HDRIP       = 10;
    const QTYPE_OTHER       =  0;

    const QDR_DV            = 9;
    const QDR_HDR10P        = 8;
    const QDR_HDR           = 7;
    const QDR_SDR           = 0;

    const QSD_DVD           = 4;
    const QSD_DVDRIP        = 3;
    const QSD_OTHER         = 0;

    private static $TAG_TO_QRES = array(
        '2160p' => self::QRES_2160P,
        '1440p' => self::QRES_1440P,
        '1080p' => self::QRES_1080P,
        '1080i' => self::QRES_1080I,
        '720p' => self::QRES_720P,
        'sd' => self::QRES_SD,
        '' => self::QRES_SD);

    private static $TAG_TO_QTYPE = array(
        'BluRay' => self::QTYPE_BLURAY,
        'BluRay.Custom' => self::QTYPE_BLURAY,
        'BDRemux' => self::QTYPE_BLURAY,
        'HDDVD' => self::QTYPE_HDDVD,
        'HDDVDRemux' => self::QTYPE_HDDVD,
        'BDRip' => self::QTYPE_BDRIP,
        'HDDVDRip' => self::QTYPE_HDDVDRIP,
        'WebDl' => self::QTYPE_WEBDL,
        'HDTV' => self::QTYPE_HDTV,
        'WebRip' => self::QTYPE_WEBRIP,
        'HDTVRip' => self::QTYPE_HDTVRIP,
        'HDRip' => self::QTYPE_HDRIP,
        '' => self::QTYPE_OTHER);

    private static $TAG_TO_QDR = array(
        'DV' => self::QDR_DV,
        'HDR10+' => self::QDR_HDR10P,
        'HDR' => self::QDR_HDR,
        '' => self::QDR_SDR);

    private static $TAG_TO_QSD = array(
        'DVD.Custom' => self::QSD_DVD,
        'DVD' => self::QSD_DVD,
        'DVDRip' => self::QSD_DVDRIP,
        '' => self::QSD_OTHER);

    private static $QRES_TO_STR = array(
        self::QRES_2160P => '4K',
        self::QRES_1440P => '2K',
        self::QRES_1080P => '1080p',
        self::QRES_1080I => '1080i',
        self::QRES_720P => '720p',
        self::QRES_RIP => 'SD',
        self::QRES_SD => 'SD');

    private static $QTYPE_TO_STR = array(
        self::QTYPE_BLURAY => 'Blu-ray',
        self::QTYPE_HDDVD => 'HD-DVD',
        self::QTYPE_BDRIP => 'BDRip',
        self::QTYPE_HDDVDRIP => 'HD-DVDRip',
        self::QTYPE_WEBDL => 'WEB-DL',
        self::QTYPE_HDTV => 'HDTV',
        self::QTYPE_WEBRIP => 'WEB-DLRip',
        self::QTYPE_HDTVRIP => 'HDTVRip',
        self::QTYPE_HDRIP => 'HDRip',
        self::QTYPE_OTHER => '');

    private static $QDR_TO_STR = array(
        self::QDR_DV => 'DV',
        self::QDR_HDR10P => 'HDR10+',
        self::QDR_HDR => 'HDR',
        self::QDR_SDR => '');

    private static $QSD_TO_STR = array(
        self::QSD_DVD => 'DVD',
        self::QSD_DVDRIP => 'DVDRip',
        self::QSD_OTHER => '');

    ///////////////////////////////////////////////////////////////////////

    private static $SEASON_TAGS = array(
        's', 'season', 'seasons', 'сезон', 'сезоны', 'сезона', 'сезонов');
    private static $EP_TAGS = array(
        'episode', 'серия', 'серии', 'серий', 'episodio');
    private static $ALL_NUMBERS_SUFFIX_TAGS = array(
        'сезона', 'сезонов', 'серии', 'серий');
    private static $TOTAL_SUFFIX_TAGS = array('из');
    private static $AFTER_NAME_ALLOWED = array(
        'трилогия', 'сезон', 'серии', 'коллекционное');

    ///////////////////////////////////////////////////////////////////////

    public function __construct($movie_names, $remove_movie_names,
        $movie_series, $movie_years, $movie_season_numbers,
        $good,
        $orig_name, $size_mb, $seeds, $leeches)
    {
        $this->movie_names = $movie_names;
        $this->remove_movie_names = $remove_movie_names;
        $this->movie_series = $movie_series;
        $this->movie_first_year = intval($movie_years);
        $this->movie_season_numbers = $movie_season_numbers ?
            (array) $movie_season_numbers : array();

        // NOTE: creating new set because for some unknown reason the
        // isset($movie_season_numbers[$n]) does not work properly

        $this->movie_sset = array();
        foreach ($this->movie_season_numbers as $s => $dummy) {
            $this->movie_sset[(int) $s] = 1;
        }

        $this->good = $good;

        $this->orig_name = $orig_name;
        $this->size_mb = $size_mb;
        $this->seeds = $seeds;
        $this->leeches = $leeches;

        $new_names = array();
        foreach ($this->movie_names as &$v) {
            $v = str_replace(array('ё', 'Ё'), array('е', 'Е'), $v);
            if (false !== strpos($v, "'"))
                $new_names[] = str_replace("'", '', $v);
        }
        foreach ($new_names as $name)
            $this->movie_names[] = $name;
        unset($v);
    }

    public function is_single_season()
    {
        return $this->movie_series && count($this->movie_sset) == 1;
    }

    public function get_caption($season)
    {
        $caption = $this->bonus ? "[Bonus] " : "";
        $caption .= $this->quality_str;
        $otags = $this->get_other_tags_str();
        if ($otags)
            $caption .= " | $otags";
        if ($this->name && ($this->invalid || $this->remove_movie_names))
            $caption .= " | $this->name";
        if ($this->tail)
            $caption .= " | $this->tail";
        if ($this->se_str) {
            if ($season == -1 || count($this->seasons) != 1 ||
                $this->seasons[0] != $season)
            {
                $caption .= " | $this->se_str";
            } else if ($this->single_episode >= 0) {
                $caption .= " | E$this->single_episode";
            } else {
                $pos = strpos($this->se_str, ' E');
                if ($pos)
                    $caption .= " | " . substr($this->se_str, $pos + 1);
            }
        }
        if ($this->add_content)
            $caption .= " |$this->add_content";
        return $caption;
    }

    public function get_other_tags_str() {
        $res = '';
        foreach (self::$KNOWN_TAGS_ORDER as $tag => $n) {
            if (isset($this->tags[$tag]))
                $res .= ($res ? ' ' : '') . $tag;
        }
        return $res;
    }

    private function set_default_parse_results()
    {
        $this->name = '';
        $this->years = '';
        $this->tail = '';
        $this->tags = array();
        $this->other_res_tags = array();
        $this->bad_tags = array();
        $this->res_quality = 0;
        $this->quality = 0;
        $this->quality_str = '';
        $this->seasons = array();
        $this->single_episode = -1;
        $this->bonus = false;
        $this->add_content = '';
        $this->add_content_ndx = -1;
        $this->left_brackets = '';
        $this->se_str = '';
        $this->invalid = false;
        $this->name_or_year_invalid = false;
        $this->flags = $this->good ? '' : 'B';
    }

    private static function ensure_static()
    {
        if (!self::$SEARCH)
        {
            self::$SEARCH = array();
            self::$IREPLACE = array();
            foreach (self::$SEARCH_IREPLACE as $s => $r) {
                self::$SEARCH[] = $s;
                self::$IREPLACE[] = $r;
            }
        }

        if (!self::$RPART_IGNORE_MAP)
        {
            self::$RPART_IGNORE_MAP = array();
            foreach (self::$RPART_IGNORE as $word)
                self::$RPART_IGNORE_MAP[$word] = 1;
        }

        if (!self::$KNOWN_TAGS_ORDER)
        {
            self::$KNOWN_TAGS_ORDER = array();
            $n = 1;
            foreach (self::$KNOWN_OTHER_TAGS as $k => $tag) {
                if (!isset(self::$KNOWN_TAGS_ORDER[$tag])) {
                    self::$KNOWN_TAGS_ORDER[$tag] = $n;
                    $n++;
                }
            }
        }
    }

    private function year_matches($year) {
        if ($year <= 0)
            return false;

        $arr = preg_split('/(19\d\d|20\d\d)/', $this->years,
            -1, PREG_SPLIT_DELIM_CAPTURE);
        $sz = count($arr);
        for ($i = 1; $i < $sz; $i += 2) {
            $y = $arr[$i];
            if ($year >= $y - 1 && $year <= $y + 1)
                return true;

            if ($i >= 2 && $arr[$i - 1] == '-') {
                $prev_y = $arr[$i - 2];
                if ($year >= $prev_y && $year <= $y)
                    return true;
            }
        }

        return false;
    }

    private function movie_year_matches()
    {
        if (!$this->movie_first_year)
            return true;
        return $this->year_matches($this->movie_first_year);
    }

    private function season_year_matches()
    {
        if (!$this->movie_season_numbers)
            return false;

        foreach ($this->seasons as $s_num) {
            $s = HD::get($this->movie_season_numbers, $s_num);
            if ($s && $this->year_matches($s->year))
                return true;
        }
        return false;
    }

    public function parse()
    {
        self::ensure_static();

        $this->set_default_parse_results();

        $this->replaced_name = str_ireplace(
            self::$SEARCH, self::$IREPLACE, $this->orig_name);

        $arr = $this->parse_years();

        $lpart = trim($arr[0]);
        $rpart = trim($arr[1]);

        $lpart1 = $this->validate_name($lpart, true);
        list($rpart2, $rpos2) = $this->parse_tags($rpart, true);
        list($lpart2, $lpos2) = $this->parse_tags($lpart1, false);
        $lpart3 = '';

        $this->fill_seasons_from_episodes();

        if (!$this->years) {
            $this->invalid = true;
            $this->flags .= 'Y';
        }
        else if (!$this->movie_year_matches() &&
            !$this->season_year_matches())
        {
            $sstrs = array();
            foreach ($this->movie_season_numbers as $s)
                $sstrs[] = $s->year;
            $debug_sstr = $sstrs ? "seasons " . implode(',', $sstrs) : "";
            if (self::DEBUG_INVALID) {
                hd_print("QQQ torrent year not match with movie: ".
                    "'$this->years' vs '$this->movie_first_year' $debug_sstr; name: $this->orig_name");
            }
            $this->flags .= 'E';
            $this->name_or_year_invalid = true;
            $this->invalid = true;
        }

        if (!$this->tags && $this->bad_tags) {
            $this->flags .= 'T';
            $this->name_or_year_invalid = true;
            $this->invalid = true;
        }

        $this->tail = $rpart2;
        $brackets = $this->remove_movie_names || $this->invalid ?
            '' : $this->left_brackets;
        $bsep = $brackets ? ' ' : '';
        if ($lpos2 >= 0) {
            $lpart3 = substr($lpart2, $lpos2);
            $lpart3 = self::remove_begin_seps($lpart3);
            $lpart2 = substr($lpart2, 0, $lpos2);
            $lpart2 = self::remove_end_seps($lpart2);

            $this->name = $lpart2;
            $this->tail = $lpart3 . $bsep . $brackets .
                ($lpart3 && $rpart2 && !$brackets ? ', ' : '') . $rpart2;
        } else {
            $this->name = $lpart2;
            $this->tail = $brackets . $bsep . $rpart2;
        }
        $this->tail = trim($this->tail);

        if (!$this->invalid && ($this->good || $this->remove_movie_names))
            $this->name = trim($this->validate_name($this->name, false));

        $this->validate_tags();

        list($this->quality, $this->quality_str, $this->res_quality) =
            $this->get_quality_from_tags();

        if ($this->movie_series)
            $this->make_se_str();

        if (LangHelper::$avoid_cyr)
        {
            if ($this->tail)
                $this->apply_cyr2eng($this->tail);
            if ($this->add_content)
                $this->apply_cyr2eng($this->tail);
        }
    }

    static $cyr2eng = array(
        '|Оригинальный видеоряд|ui' => 'Original video',
        '|Локализованный видеоряд|ui' => 'Localized video',
        '|Гаврилов|ui' => 'Gavrilov',
        '|\bСтудия\b|ui' => 'Studio',
        '|Пифагор|ui' => 'Pythagoras',
        '|Театральная версия|ui' => 'Theatrical Cut',
        '|Режиссерская версия|ui' => "Director`s Cut",
        '|Расширенная версия|ui' => "Extended Edition",
    );

    static $cyr2eng_from = null;
    static $cyr2eng_to = null;

    private static function ensure_cyr2eng()
    {
        if (isset(self::$cyr2eng_from))
            return;

        self::$cyr2eng_from = array_keys(self::$cyr2eng);
        self::$cyr2eng_to = array_values(self::$cyr2eng);
    }
    
    private function apply_cyr2eng(&$str)
    {
        $this->ensure_cyr2eng();

        $str = preg_replace(self::$cyr2eng_from, self::$cyr2eng_to, $str);
    }

    private function make_se_str()
    {
        if ($this->single_episode >= 0) {
            $s = $this->seasons[0];
            $e = $this->single_episode;
            $this->se_str = "S$s: E$e";
        } else if ($this->seasons) {
//            $res = count($this->seasons) == 1 ? "Season " : "Seasons ";
            $res = "S";
            $s1 = $s2 = $this->seasons[0];
            $res .= $s1;
            for ($i = 1; $i < count($this->seasons); $i++) {
                $s = $this->seasons[$i];
                if ($s == $s2 + 1) {
                    $s2++;
                    continue;
                }

                if ($s2 > $s1)
                    $res .= "-$s2";

                $s1 = $s2 = $s;
                $res .= ",$s1";
            }

            if ($s2 > $s1)
                $res .= "-$s2";
            $this->se_str = $res;
        }

        $eps = $this->episodes;
        if ($this->single_episode < 0 &&
            $eps->from > 0 && $eps->to >= $eps->from)
        {
            if ($this->se_str)
                $this->se_str .= ' ';
            $this->se_str .= "E$eps->from";
            if ($eps->to > $eps->from)
                $this->se_str .= "-$eps->to";
        }
    }

    private function validate_tags()
    {
        $tags = &$this->tags;

        if (isset($tags['BluRay']) && isset($tags['BDRip']))
            unset($tags['BluRay']);

        if (!$this->movie_series && !$this->bonus &&
            isset($tags['BluRay']) && $this->size_mb < 20000)
        {
            unset($tags['BluRay']);
            $tags['BDRip'] = 1;
        }

        if (isset($tags['BluRay']) &&
            !isset($tags['1080p']) && !isset($tags['2160p']) &&
            (isset($tags['1440p']) || isset($tags['720p']) ||
             isset($tags['SD'])))
        {
            $lc = $tags['BluRay'];
            unset($tags['BluRay']);
            $tags['BDRip'] = $lc;
        }

        if (isset($tags['BDRip']) || isset($tags['WebRip']) ||
            isset($tags['HDRip']))
        {
            unset($tags['UHD']);
        }
    }

    private static function is_valid_name_sep($sep, $left, $space_allowed=false) {
        if ($sep)
            $sep = $sep[strlen($sep) - 1];
        if (!isset($sep) ||
            $sep == '/' || $sep == '(' || $sep == ')' ||
            ($space_allowed && $sep == ''))
        {
            return true;
        }

        if (!$left && ($sep == ',' || $sep == '.' || $sep == '[' || $sep == '-'))
            return true;
        if ($left && $sep == ']')
            return true;

        return false;
    }

    private static function is_valid_name_sep_pair($sep1, $sep2) {
        if ($sep2 == '-')
            return !isset($sep1);

        if (!isset($sep1) || !isset($sep2))
            return true;

        if ($sep2 == ',' && ($sep1 == '/' || $sep1 == '|'))
            return false;

        return true;
    }

    private static function iscyr($c)
    {
        if (strlen($c) < 2)
            return false;
        $n1 = ord($c[0]);
        $n2 = ord($c[1]);
        return ($n1 == 0xD0 && ($n2 >= 0x90 && $n2 <= 0xBF)) ||
            ($n1 == 0xD1 && ($n2 >= 0x80 && $n2 <= 0x91));
    }

    private static function is_valid_word_after_name($w1, $w2)
    {
        if (!$w1 || !$w2)
            return true;

        if (!self::iscyr($w1) || !self::iscyr($w2))
            return true;

        return in_array($w2, self::$AFTER_NAME_ALLOWED);
    }

    private function validate_name_in_arr(&$arr, $check_only)
    {
        $sz = count($arr);
        $found = false;
        foreach ($this->movie_names as $movie_name)
        {
            $arr2 = self::split_by_delims($movie_name, true);
            if (!$arr2)
                continue;
            $space_allowed =
                mb_strlen($movie_name, 'UTF-8') > 10 ||
                count($arr2) >= 5;

            $sz2 = count($arr2);
            for ($i = 0; $i < $sz; $i += 2)
            {
                $sep1 = $i == 0 ? null : trim($arr[$i - 1]);
                if (!self::is_valid_name_sep($sep1, 1))
                    continue;

                $equals = 1;
                for ($j = 0, $k = $i; $j < $sz2; $j += 2, $k += 2)
                {
                    if ($k >= $sz) {
                        $equals = 0;
                        break;
                    }

                    $lc = self::lc($arr, $k);
                    $lc2 = $arr2[$j];
                    if ($lc == $lc2)
                        continue;

                    // Hack for Star Wars.
                    if ($j >= 4) {
                        if ($j < $sz2 - 4 && ($lc2 == 'episode' || $lc2 == 'эпизод')) {
                            $j += 4;
                            $lc2 = $arr2[$j];
                        } else if ($k < $sz - 4 && ($lc == 'episode' || $lc == 'эпизод')) {
                            $k += 4;
                            $lc = self::lc($arr, $k);
                        }
                        if ($lc == $lc2)
                            continue;
                    }

                    $equals = 0;
                    break;
                }
                if (!$equals)
                    continue;

                $k -= 2;
                $sep2 = $k < $sz - 1 ? trim($arr[$k + 1]) : null;
                $w1 = self::lc($arr, $k);
                $w2 = self::lc($arr, $k + 2);

                $next_word_is_ok = false;
                if ($this->movie_series && $w2 &&
                    (in_array($w2, self::$SEASON_TAGS) ||
                     preg_match('|^s\d|', $w2)))
                {
                    $next_word_is_ok = true;
                } else if (
                    isset(self::$KNOWN_TAGS[$w2]) ||
                    isset(self::$KNOWN_OTHER_TAGS[$w2]) ||
                    isset(self::$TAG_REPL[$w2]) ||
                    isset(self::$TAG_JOIN[$w2]))
                {
                    $next_word_is_ok = true;
                }
                if ($next_word_is_ok)
                    $space_allowed = true;

                if (!self::is_valid_name_sep($sep2, 0, $space_allowed)) {
                    continue;
                }
                if (!self::is_valid_name_sep_pair($sep1, $sep2)) {
                    continue;
                }

                if ($sep2 == '.') {
                    if (!self::is_valid_word_after_name($w1, $w2))
                    {
                        if (self::DEBUG_INVALID) {
                            hd_print("QQQ movie name '$movie_name' rejected ".
                                "by following word !! (orig: $this->orig_name)");
                        }
                        continue;
                    }
                } else if ($sep2 == '') {
                }

                $found = true;

                if (!$check_only && !$this->invalid &&
                    ($this->remove_movie_names || $this->good))
                {
                    for ($j = $i; $j <= min($k, $sz - 1); $j++)
                        $arr[$j] = '';
                }
            }
        }

        if (self::DEBUG_INVALID && !$found) {
            $x = self::join_simple($arr);
            hd_print("QQQ movie names -- ". implode(",", $this->movie_names).
                " -- not found in $this->replaced_name");
        }

        return $found;
    }

    private function get_quality_by_map($map) {
        foreach ($map as $tag => $q) {
            if (isset($this->tags[$tag]))
                return $q;
        }
        return $map[''];
    }

    private function get_quality_from_tags()
    {
        $qres = $this->get_quality_by_map(self::$TAG_TO_QRES);
        $qtype = $this->get_quality_by_map(self::$TAG_TO_QTYPE);
        if ($qtype >= self::QTYPE_HDRIP && $qres == self::QRES_SD)
            $qres = self::QRES_RIP;

        if ($qtype >= self::QTYPE_HDRIP)
            $q3 = $this->get_quality_by_map(self::$TAG_TO_QDR);
        else
            $q3 = $this->get_quality_by_map(self::$TAG_TO_QSD);

        $q = $qres + $qtype + $q3;

        $qtype_str = self::$QTYPE_TO_STR[$qtype];

        if ($qtype >= self::QTYPE_HDRIP)
            $q3_str = self::$QDR_TO_STR[$q3];
        else
            $q3_str = self::$QSD_TO_STR[$q3];

        $sd = $qres == self::QRES_RIP || $qres == self::QRES_SD;
        if ($sd && $this->other_res_tags) {
            $qres_str = implode(' ', array_keys($this->other_res_tags));
        } else if ($sd && ($q3_str || $qtype_str)) {
            $qres_str = '';
        } else {
            $qres_str = self::$QRES_TO_STR[$qres];
        }

        $qstr = $qres_str;
        if ($q3_str)
            $qstr .= ($qstr ? ' ' : '') . $q3_str;
        if ($qtype_str)
            $qstr .= ($qstr ? ' ' : '') . $qtype_str;

        return array($q, $qstr, $qres);
    }

    private function get_total_episodes_count($max_season)
    {
        $n = 0;
        for ($s = 1; $s <= $max_season && isset($this->movie_sset[$s]); $s++)
            $n += $this->movie_season_numbers[$s]->episodes_count;
        return $n;
    }

    private function season_from_episode($e) {
        $start_e = 1;
        for ($s = 1; isset($this->movie_sset[$s]); $s++) {
            $ss = $this->movie_season_numbers[$s];
            if ($e >= $start_e && $e < $start_e + $ss->episodes_count)
                return $s;
            $start_e += $ss->episodes_count;
        }
        return -1;
    }

    private function add_season($s) {
        if (!isset($this->movie_sset[$s]))
            return false;
        $this->seasons[] = $s;
        return true;
    }

    private function fill_seasons_from_episodes() 
    {
        if (!$this->movie_series)
            return;
        if ($this->single_episode >= 0 || $this->seasons)
            return;

        $eps = $this->episodes;
        if ($eps->from <= 0 || $eps->from > $eps->to)
            return;

        $from_s = $this->season_from_episode($eps->from);
        $to_s = $this->season_from_episode($eps->to);
        if ($from_s > 0 && $to_s > 0) {
            $this->seasons = array();
            for ($s = $from_s; $s <= $to_s; $s++)
                $this->add_season($s);
        }
    }

    public function has_episode($s, $e)
    {
        if ($this->invalid)
            return false;

        if ($this->single_episode >= 0) {
            return $e == $this->single_episode &&
                $s == $this->seasons[0];
        }

        if (!in_array($s, $this->seasons))
            return false;

        $eps = $this->episodes;
        if ($eps->from <= 0 || $eps->to < $eps->from)
            return true;

        if (count($this->seasons) == 1 && $eps->from == 1)
            return $e >= $eps->from && $e <= $eps->to;

        $min_s = max(1, $this->seasons[0]);
        $n = $this->get_total_episodes_count($min_s);
        if ($eps->from != $n + 1) {
            hd_print("QQQ inconsistent ep numbers for: $this->orig_name");
            return true;
        }

        $e += $this->get_total_episodes_count($s - 1);
        return $e >= $eps->from && $e <= $eps->to;
    }

    private function parse_years()
    {
        $movie_name = $this->movie_names[0];
        if (preg_match('/19\d\d|20\d\d/', $movie_name, $m))
            $this->movie_name_year = $m[0];

        // Looking for first year occurence.

        $arr = preg_split('/(19\d\d|20\d\d)/', $this->replaced_name,
            -1, PREG_SPLIT_DELIM_CAPTURE);

        $sz = count($arr);

        $base = '';
        for ($i = 1; $i < $sz; $i += 2)
        {
            if ($i > 1)
                $base .= $arr[$i - 2];
            $base .= $arr[$i - 1];
            $baselen = strlen($base);

            $sep = $arr[$i];
            $word = $i < $sz - 1 ? $arr[$i + 1] : '';

            $prev_char = $baselen == 0 ? '' : $base[$baselen - 1];
            if (ctype_digit($prev_char))
                continue;

            $next_char = $word == '' ? '' : $word[0];
            if (ctype_digit($next_char))
                continue;

            if ($this->movie_name_year && $sep == $this->movie_name_year)
                continue;

            break;
        }

        if ($i >= $sz)
            return array($this->replaced_name, '');

        // Adding consequent years (split by '-', ',', etc)

        $sep = '';
        $years = '';

        for (; $i < $sz; $i += 2)
        {
            $y = $arr[$i];
            $word = $i < $sz - 1 ? trim($arr[$i + 1]) : '';

            $years .= "$sep$y";

            if (strpos($word, "г.") === 0)
                $word = $arr[$i + 1] = trim(substr($word, strlen("г.")));

            if ($word == '-' || $word == '—' || $word == '–') {
                $sep = '-';
                continue;
            }
            if ($word == '' || $word == ',' || $word == '/' || $word == '+' || $word == '.') {
                $sep = ',';
                continue;
            }

            $arr2 = self::split_by_delims($word, false);
            self::split_close_open_seps($arr2);
            for ($j = 0; $j < count($arr2); $j += 2)
            {
                $v = mb_strtolower($arr2[$j], 'UTF-8');
                if ($v != '' && $v != 'г' && !isset(self::$RPART_IGNORE_MAP[$v]))
                    break;
            }

            if ($j == 0) {
                $i++;
                break;
            }
            if ($j >= count($arr2)) {
                $sep = ',';
                continue;
            }

            $from2 = 1 == self::get_sep_type($arr2[$j - 1]) ? $j - 1 : $j;
            $arr[$i + 1] = implode('', array_slice($arr2, $from2));
            $i++;
            break;
        }

        $lpart = $base;
        $this->years = $years;

        $lpart = self::remove_end_seps($lpart);

        if ($i >= $sz)
            return array($lpart, '');

        $rpart = implode('', array_slice($arr, $i));
        return array($lpart, $rpart);
    }

    private static function is_open_char($c) {
        return $c == '(' || $c == '[' || $c == '{';
    }

    private static function is_close_char($c) {
        return $c == ')' || $c == ']' || $c == '}';
    }

    /**
     * -1 => begin/end
     * 0 => normal (like ',')
     * 1 => opening (like '(')
     * 2 => closing (like ')')
     */
    private static function get_sep_type($sep)
    {
        if (!isset($sep))
            return -1;
        $sep = trim($sep);
        if (!$sep)
            return 0;

        $c = $sep[0];
        if (self::is_close_char($c))
            return 2;

        $c = $sep[strlen($sep) - 1];
        if (self::is_open_char($c))
            return 1;

        return 0;
    }

    private static function get_sep_depth($sep) {
        $sep = trim($sep);
        if (!$sep)
            return 0;
        $len = strlen($sep);
        $depth = 0;
        $n = 0;
        if (self::is_close_char($sep[$n])) {
            $depth = 1;
            for ($n++; $n < $len; $n++) {
                if (ctype_space($sep[$n]))
                    continue;
                if (self::is_close_char($sep[$n]))
                    $depth++;
                else
                    break;
            }
        } else {
            $n = $len - 1;
            if (self::is_open_char($sep[$n])) {
                $depth = 1;
                for ($n--; $n >= 0; $n--) {
                    if (ctype_space($sep[$n]))
                        continue;
                    if (self::is_open_char($sep[$n]))
                        $depth++;
                    else
                        break;
                }
            }
        }
        return $depth;
    }

    private static function is_close_open_sep($sep)
    {
        $sep = trim($sep);
        if (!$sep)
            return false;
        $c1 = $sep[0];
        $c2 = $sep[strlen($sep) - 1];
        return self::is_close_char($c1) &&
            self::is_open_char($c2);
    }

    // Splitting close-open sep to <close-sep> + '' + <open-sep>
    private static function split_close_open_seps(&$arr)
    {
        for ($i = 1; $i < count($arr); $i += 2)
        {
            $sep = $arr[$i];
            if (!self::is_close_open_sep($sep))
                continue;

            $n = 0;
            while ($n < strlen($sep) &&
                ($sep[$n] == ' ' || self::is_close_char($sep[$n])))
            {
                $n++;
            }

            $sep1 = substr($sep, 0, $n);
            $sep2 = substr($sep, $n);
            $arr[$i] = $sep1;
            array_splice($arr, $i + 1, 0, array('', $sep2));
            $i += 2;
        }
    }

    private static function word_is_empty($word) {
        return trim($word) == '';
    }

    private static function str_has_sep_char($str) {
        $dchars = ' +!"#$%&\'()\*,-\.\/:;<=>\?@\[\\\\\]\^_\{\|\}`~';
        return preg_match("/[$dchars]/", $str);
    }

    private static function remove_open_chars($sep) {
        $n = strlen($sep);
        while ($n > 0 && self::is_open_char($sep[$n - 1]))
            $n--;
        $v = trim(substr($sep, 0, $n));
        return $v ? $v : ', ';
    }

    private static function remove_close_chars($sep) {
        $n = 0;
        while ($n < strlen($sep) && self::is_close_char($sep[$n]))
            $n++;
        $v = trim(substr($sep, $n));
        return $v ? $v : ', ';
    }

    private static function normalize_seps_once(&$arr, $it_number)
    {
        $last_sep_i = -2;
        $last_sep_level = -1;
        $num_changes = 0;
        $level = 0;

        for ($i = 0; $i < count($arr); $i++)
        {
            $v = self::lc($arr, $i);

            $is_sep = $i % 2 == 1;

            if (!$is_sep) {
                if ($v != '')
                    $last_sep_i = -2;
                else if ($i == 0)
                    $last_sep_i = -1;
                continue;
            }

            $sep2 = $v;
            if ($sep2 == '')
                continue;
            $t2 = self::get_sep_type($sep2);

            $nchanges = 0;

            if ($last_sep_i >= -1)
            {
                $sep1 = $last_sep_i == -1 ? null : $arr[$last_sep_i];
                $t1 = self::get_sep_type($sep1);

                if ($t1 == 0 && ($t2 == 2 || $t2 == 1 || $t2 == -1)) {
                    $arr[$last_sep_i] = '';
                    $nchanges++;
                } else if ($t1 == 1 && ($t2 == 2 || $t2 == -1)) {
                    $depth = self::get_sep_depth($sep1);
                    $arr[$last_sep_i] = self::remove_open_chars($sep1);
                    $level = max(0, $level - $depth);
                    $nchanges++;
                } else if ($t1 == 2 && $last_sep_level == 0) {
                    $depth = self::get_sep_depth($sep1);
                    $arr[$last_sep_i] = self::remove_close_chars($sep1);
                    $level += $depth;
                    $nchanges++;
                }

                if ($t2 == 2 && $t1 == -1) {
                    $sep2 = $arr[$i] = '';
                    $nchanges++;
                } else if ($t2 == 2 && $t1 == 1) {
                    $sep2 = $arr[$i] = self::remove_close_chars($sep2);
                    $nchanges++;
                } else if ($t2 == 0) {
                    $sep2 = $arr[$i] = '';
                    $nchanges++;
                }
                if ($nchanges > 0)
                    $t2 = self::get_sep_type($sep2);
            }

            if ($t2 == 2 && $level == 0) {
                $arr[$i] = self::remove_close_chars($sep2);
                $nchanges++;
            }

            $num_changes += $nchanges;

            $sep = $arr[$i];

            if ($sep) {
                $last_sep_i = $i;
                $last_sep_level = $level;
            }

            $t = self::get_sep_type($sep);
            $depth = self::get_sep_depth($sep);
            $level += $t == 1 ? $depth : ($t == 2 ? -$depth : 0);
        }

        return $num_changes;
    }

    private static function lc(&$arr, $ndx)
    {
        $v = HD::arrget($arr, $ndx);
        return is_array($v) ? $v[1] : $v;
    }

    private static function uc(&$arr, $ndx)
    {
        $v = HD::arrget($arr, $ndx);
        return is_array($v) ? $v[0] : $v;
    }

    private static function sep(&$arr, $ndx)
    {
        $v = HD::arrget($arr, $ndx);
        return $v;
    }

    private static function join_simple($arr, $from=null, $to=null) {
        list($x, $dummy) = self::join_parse_arr($arr, -1, $from, $to);
        return $x;
    }

    private static function join_parse_arr($arr, $first_tag_index, $from=null, $to=null) {
        $res = '';
        $first_tag_pos = -1;

        if (!isset($from))
            $from = 0;
        if (!isset($to))
            $to = count($arr) - 1;

        for ($i = $from; $i <= $to; $i++) {
            $v = $arr[$i];
            $val = is_array($v) ? $v[0] : $v;

            if ($res == '' && $val == ', ')
                continue;

            if ($i == $first_tag_index)
                $first_tag_pos = strlen($res);

            $res .= $val;
        }

        $res = self::remove_end_seps($res);

        if ($first_tag_pos >= strlen($res))
            $first_tag_pos = -1;

        return array($res, $first_tag_pos);
    }

    private static function remove_end_seps($name)
    {
        for ($n = strlen($name); $n > 0; $n--) {
            $c = $name[$n - 1];
            if (self::is_close_char($c) || !self::str_has_sep_char($c))
                break;
        }
        if ($n == strlen($name))
            return $name;
        return substr($name, 0, $n);
    }

    private function remove_begin_seps($name)
    {
        $len = strlen($name);
        for ($n = 0; $n < $len; $n++) {
            $c = $name[$n];
            if (self::is_open_char($c) || !self::str_has_sep_char($c))
                break;
        }
        if ($n == 0)
            return $name;
        return substr($name, $n);
    }

    private static function split_by_delims($name, $to_lc=false)
    {
        $dchars = ' +!"#$%&\'()\*,-\.\/:;<=>\?@\[\\\\\]\^_\{\|\}`~';
        $arr = preg_split("/([$dchars]+)/", $name,
            -1, PREG_SPLIT_DELIM_CAPTURE);
        if ($to_lc) {
            foreach ($arr as $ndx => &$v) {
                if ($ndx % 2 == 0)
                    $v = mb_strtolower($v, 'UTF-8');
            }
            unset($v);
        }
        return $arr;
    }

    public static function trim_special_chars($name)
    {
        $chars = ' +!"#$%&\'()*,-./:;<=>?@[\\]^_{|}`~';
        return trim($name, $chars);
    }

    private static function get_sep_prio($sep, $fwd)
    {
        if (!isset($sep))
            return 9;
        $sep = trim($sep);
        if ($sep == '') return 0;
        if ($sep == '-' || $sep == ':' || $sep == '.')
            return 1;
        if ($fwd && $sep == '(')
            return 2;
        return 8;
    }

    private static function is_res_tag($tag) {
        if (!$tag)
            return false;
        $len = strlen($tag);
        if (!ctype_digit($tag[0]) || $tag[$len - 1] != 'p')
            return false;
        for ($i = 1; $i < $len - 1; $i++)
            if (!ctype_digit($tag[$i]))
                return false;
        return true;
    }

    private static function parse_total_suffix(&$arr, $from)
    {
        if ($from + 3 >= count($arr))
            return 0;

        $sep1 = trim($arr[$from + 1]);
        $lc1 = self::lc($arr, $from + 2);
        $sep2 = trim($arr[$from + 3]);
        $lc2 = self::lc($arr, $from + 4);

        if (in_array($lc1, self::$TOTAL_SUFFIX_TAGS) &&
            $sep2 == '' && $lc2 && is_numeric($lc2))
        {
            $arr[$from + 2] = $arr[$from + 3] = $arr[$from + 4] = '';
            return (int) $lc2;
        }

        if ($sep1 == '(' && $sep2 == ')' && is_numeric($lc1))
        {
            $arr[$from + 1] = $arr[$from + 2] = '';
            $arr[$from + 3] = ', ';
            return (int) $lc1;
        }

        return 0;
    }

    private function parse_seasons_episodes(&$arr)
    {
        if (!$this->movie_series)
            return -1;

        $eps = (object) array(
            'from' => 0, 'to' => 0, 'total' => 0);

        for ($i = 0; $i < count($arr); $i += 2)
        {
            $lc = self::lc($arr, $i);

            $e = -1;
            $tag = null;
            $fwd = null;
            foreach (self::$EP_TAGS as $etag) {
                if ($lc == $etag) {
                    $tag = $etag;
                } else if (preg_match("|^$etag([0-9]+)$|", $lc, $m)) {
                    $tag = $etag;
                    $e = intval($m[1]);
                    $fwd = true;
                } else if (preg_match("|^([0-9]+)$etag$|", $lc, $m)) {
                    $tag = $etag;
                    $e = intval($m[1]);
                    $fwd = false;
                }
                if ($tag)
                    break;
            }
            if (!$tag)
                continue;

            $sep1 = $i > 0 ? $arr[$i - 1] : null;
            $sep2 = $i < count($arr) - 1 ? $arr[$i + 1] : null;
            $p1 = self::get_sep_prio($sep1, false);
            $p2 = self::get_sep_prio($sep2, true);
            if ($p1 >= 8 && $p2 >= 8)
                continue;

            $next = self::lc($arr, $i + 2);
            $fwd = $fwd && $p2 < 8 ? true :
                ($fwd === false && $p1 < 8 ? false :
                 ($p1 != $p2 ? $p2 < $p1 :
                  $next && is_numeric($next) && $next > 0));
            $inc = $fwd ? 1 : -1;

            $ee = $e > 0 ? array($e) : array();
            $ndx = $i + $inc * 2;
            for (; $ndx >= 0 && $ndx < count($arr); $ndx += $inc * 2)
            {
                if (count($ee) == 2)
                    break;

                $lc2 = self::lc($arr, $ndx);
                if (!is_numeric($lc2) || $lc2 <= 0)
                    break;

                if (count($ee) > 0) {
                    $sep = trim($arr[$ndx - $inc]);
                    if ($sep != '-' && $sep != ',')
                        break;
                }

                $ee[] = (int) $lc2;
            }
            if (!$ee)
                continue;
            $ndx -= $inc * 2;

            if (!$fwd)
                $ee = array_reverse($ee);

            if (count($ee) == 2 && $ee[1] > $ee[0]) {
                $eps->from = $ee[0];
                $eps->to = $ee[1];
            } else if (!$fwd && in_array($lc, self::$ALL_NUMBERS_SUFFIX_TAGS)) {
                $eps->from = 1;
                $eps->to = $ee[0];
            } else {
                $eps->from = $ee[0];
                $eps->to = $ee[0];
            }

            $from = $fwd ? $i : $ndx;
            $to = $fwd ? $ndx : $i;

            for ($ndx = $from; $ndx <= $to; $ndx++)
                $arr[$ndx] = '';
            $arr[$i] = '';

            $from = max($i, $to);
            $eps->total = self::parse_total_suffix($arr, $from);

            if (self::get_sep_prio($arr[$from + 1], 1) < 2)
                $arr[$from + 1] = ', ';
            break;
        }

        $this->episodes = $eps;
        return -1;
    }

    private function parse_brackets(&$arr)
    {
        for ($i = 2; $i < count($arr); $i += 2)
        {
            $lsep = self::sep($arr, $i - 1);
            $trlsep = trim($lsep);
            if ($trlsep != '[')
                continue;

            $skip = 0;
            $level = 1;
            $text = '[';
            for ($j = $i; $j + 1 < count($arr); $j += 2)
            {
                $sep = self::sep($arr, $j + 1);
                $uc = self::uc($arr, $j);

                $trsep = trim($sep);
                if ($trsep == '[') {
                    $level++;
                    $skip = 1;
                } else if ($trsep == ']') {
                    $level--;
                }
                $text .= $uc . $sep;
                if ($level == 0)
                    break;
            }
            if ($level != 0)
                break;

            if ($this->parse_episodes_in_brackets($arr, $i, $j))
                $skip = 1;

            if ($this->name_or_year_invalid)
                $skip = 1;

            $i = $j;
            if ($skip)
                continue;

            if ($this->left_brackets)
                $this->left_brackets .= ' ';
            $this->left_brackets .= $text;
        }
    }

    private static function add_range(&$ranges,
        $multiply_single, $n1, $n2=null)
{
        if (!$n2) {
            $from = $multiply_single ? 1 : $n1;
            $r = (object) array('from' => $from, 'to' => $n1);
        } else {
            if ($n2 <= $n1)
                return false;
            $r = (object) array('from' => $n1, 'to' => $n2);
        }
        $ranges[] = $r;
        return true;
    }

    private static function parse_ranges(&$arr, $from, $to,
        $allow_single, $multiply_single)
    {
        $ranges = array();
        $end_n = null;
        for (;; $to -= 2)
        {
            if ($to < $from) {
                if ($end_n)
                    self::add_range($ranges, $multiply_single, $end_n);
                break;
            }

            $lc = self::lc($arr, $to);
            if (preg_match('#^(\d\d*)(x|X|х|Х)(\d\d*)$#', $lc, $m)) {
                if (!$end_n && !$allow_single)
                    return false;
                $lc2 = $m[3];
                if (!is_numeric($lc2) || $lc2 <= 0)
                    return false;
                if (!self::add_range($ranges, $multiply_single, (int) $lc2, $end_n))
                    return false;
                $end_n = null;

                $lc = $m[1];
            }

            if (!is_numeric($lc) || $lc <= 0)
                return false;
            $n = (int) $lc;

            if ($end_n) {
                if ($from < $to)
                    return false;
                if (!self::add_range($ranges, $multiply_single, $n, $end_n))
                    return false;
                break;
            }

            $end_n = $n;
            if ($from < $to) {
                $sep = trim(self::sep($arr, $to - 1));
                if ($sep != '-')
                    return false;
            } else {
                if (!$allow_single)
                    return false;
            }

            $allow_single = true;
            $multiply_single = false;
        }

        return array_reverse($ranges);
    }

    private function parse_episodes_in_brackets(&$arr, $i1, $i2)
    {
        if (!$this->movie_series)
            return false;

        if ($i1 == $i2)
            return false;

        $eps = (object) array(
            'from' => 0, 'to' => 0, 'total' => 0);

        $total = 0;
        $i3 = $i2;
        if ($i3 - $i1 >= 4) {
            $total = self::parse_total_suffix($arr, $i3 - 4);
            if ($total > 0)
                $i3 -= 4;
        }

        $ranges = self::parse_ranges($arr, $i1, $i3,
            $total > 0, $total > 0);
        if (!$ranges)
            return false;
        if (count($ranges) > 2)
            return false;

        if (count($ranges) == 2 && !$this->seasons) {
            $r = $ranges[0];
            for ($s = $r->from; $s <= $r->to; $s++) {
                $this->add_season($s);
            }
        }

        $r = $ranges[count($ranges) - 1];
        $eps->from = $r->from;
        $eps->to = $r->to;
        $eps->total = $total;

        if ($this->episodes->to <= 0)
            $this->episodes = $eps;
        
        return true;
    }

    private function parse_add_content(&$arr)
    {
        for ($i = 2; $i < count($arr); $i += 2)
        {
            $sep = self::sep($arr, $i - 1);
            $seplen = strlen($sep);
            if ($seplen < 3 || substr($sep, $seplen - 3) != ' + ')
                continue;

            if ($this->add_content_ndx == -1)
                $this->add_content_ndx = $i - 1;

            $uc = self::uc($arr, $i);
            $text = ' + ' . $uc;

            for ($ndx = $i + 2; $ndx < count($arr); $ndx += 2)
            {
                $sep = self::sep($arr, $ndx - 1);
                $trsep = trim($sep);
                if ($trsep != '' && $trsep != '.')
                    break;

                $uc = self::uc($arr, $ndx);
                $text .= $sep . $uc;
            }

            $old_sep = self::sep($arr, $i - 1);

            for ($k = $i; $k < $ndx; $k += 2)
                $arr[$k - 1] = $arr[$k] = '';

            $sep = trim(substr($old_sep, 0, $seplen - 3));
            $arr[$i - 1] = $sep ? "$sep " : ', ';

            $i = $ndx - 2;

            $this->add_content .= $text;
        }
    }

    private function parse_seasons(&$arr)
    {
        if (!$this->movie_series)
            return -1;

        $sns = $this->movie_sset;

        for ($i = 0; $i < count($arr) && !$this->seasons; $i += 2)
        {
            $lc = self::lc($arr, $i);

            if (preg_match('|^s([0-9]+)e([0-9]+)$|', $lc, $m)) {
                if ($this->add_season(intval($m[1]))) {
                    $this->single_episode = intval($m[2]);
                    $arr[$i] = '';
                }
                break;
            }

            $s = -1;
            $tag = null;
            $fwd = null;
            foreach (self::$SEASON_TAGS as $stag) {
                if ($lc == $stag) {
                    $tag = $stag;
                } else if (preg_match("|^$stag([0-9]+)$|", $lc, $m)) {
                    $tag = $stag;
                    $s = intval($m[1]);
                    $fwd = true;
                } else if (preg_match("|^([0-9]+)$stag$|", $lc, $m)) {
                    $tag = $stag;
                    $s = intval($m[1]);
                }
                if ($tag)
                    break;
            }
            if (!$tag)
                continue;

            $sep1 = $i > 0 ? $arr[$i - 1] : null;
            $sep2 = $i < count($arr) - 1 ? $arr[$i + 1] : null;
            $p1 = self::get_sep_prio($sep1, false);
            $p2 = self::get_sep_prio($sep2, true);
            if ($p1 >= 8 && $p2 >= 8) {
                if ($s > 0) {
                    $this->seasons = array();
                    $this->add_season((int) $s);
                    $arr[$i] = '';
                }
                continue;
            }

            $fwd = $fwd && $p2 < 8 ? true : $p2 <= $p1;
            $inc = $fwd ? 1 : -1;

            $ndx = $i + $inc * 2;
            for (; $ndx >= 0 && $ndx < count($arr); $ndx += $inc * 2)
            {
                $lc2 = self::lc($arr, $ndx);
                if (!is_numeric($lc2))
                    break;

                if ($s != -1 || $ndx - $inc * 2 != $i) {
                    $sep = trim($arr[$ndx - $inc]);
                    if ($sep != '-' && $sep != ',' && $sep != '.')
                        break;
                }
            }
            $ndx -= $inc * 2;

            $from = $fwd ? $i + 2 : $ndx;
            $to = $fwd ? $ndx : $i - 2;
            $this->seasons = array();
            if ($s >= 0 && isset($sns[$s]))
                $this->add_season($s);
            $prev_n = $s;
            for ($ndx = $from; $ndx <= $to; $ndx += 2)
            {
                $lc2 = self::lc($arr, $ndx);

                $n = intval($lc2);
                if ($n < 0 || $n <= $prev_n)
                    break;

                $sep = $ndx == $from && $s == -1 ? '' : $arr[$ndx - 1];
                if ($sep == '-' && $prev_n >= 0) {
                    for ($j = $prev_n + 1; $j <= $n; $j++) {
                        if (isset($sns[$j]))
                            $this->add_season($j);
                    }
                } else {
                    if (isset($sns[$n]))
                        $this->add_season($n);
                }
                $prev_n = $n;
            }

            if (!$this->seasons)
                continue;

            for ($ndx = $from; $ndx <= $to; $ndx++)
                $arr[$ndx] = '';
            $arr[$i] = '';

            $from = max($i, $to);
            self::parse_total_suffix($arr, $from);

            $arr[$i + $inc] = ', ';
        }

        if ($this->seasons)
            sort($this->seasons, SORT_NUMERIC);

        return -1;
    }

    private function validate_name($name, $check_only)
    {
        $arr = self::split_by_delims($name);

        foreach ($arr as $ndx => &$v) {
            if ($ndx % 2 == 0)
                $v = array($v, mb_strtolower($v, 'UTF-8'));
        }
        unset($v);

        if (!$this->validate_name_in_arr($arr, $check_only)) {
            $this->flags .= 'N';
            $this->name_or_year_invalid = true;
            $this->invalid = true;
        }

        return $check_only ? $name : $this->join_simple($arr);
    }

    private function parse_tags($name, $is_rpart)
    {
        $arr = self::split_by_delims($name);

        foreach ($arr as $ndx => &$v) {
            if ($ndx % 2 == 0)
                $v = array($v, mb_strtolower($v, 'UTF-8'));
        }
        unset($v);

        // Applying tags joins and replacements.

        for ($i = 0; $i < count($arr);)
        {
            $lc = self::lc($arr, $i);
            $sz = count($arr);
            $sep = $i < $sz - 1 ? $arr[$i + 1] : '';
            $psep = $i > 0 ? $arr[$i - 1] : '';
            $lc2 = self::lc($arr, $i + 2);

            if (isset(self::$TAG_JOIN[$lc])) {
                $map = self::$TAG_JOIN[$lc];
                if (isset($lc2))
                {
                    if (isset($map[$lc2])) {
                        $v = $map[$lc2];
                        if (is_array($v)) {
                            $arr[$i] = $v[0];
                            $arr[$i + 2] = $v[1];
                        } else {
                            $arr[$i] = $map[$lc2];
                            array_splice($arr, $i + 1, 2);
                        }
                        continue;
                    }
                }
            }

            if (isset(self::$TAG_REPL[$lc])) {
                $arr[$i] = self::$TAG_REPL[$lc];
                continue;
            }

            $i += 2;
        }

        self::split_close_open_seps($arr);

        // Extracting season(s) and single-episode info
        $this->parse_seasons($arr);

        // Extracting patterns like 'episodes 2-10 of 12'
        $this->parse_seasons_episodes($arr);

        $first_tag_index = -1;

        // Extracting known tags from array: adding to $this->tags array
        // and deleting in array by clearing chars; array size unchanged.

        $sz = count($arr);
        $left_empty = true;
        for ($i = 0; $i < $sz; $i += 2) {
            $lc = self::lc($arr, $i);
            $lc2 = self::lc($arr, $i + 2);

            $del = true;
            if (isset(self::$KNOWN_TAGS[$lc])) {
                $tag = self::$KNOWN_TAGS[$lc];
                $this->tags[$tag] = $lc;
                if ($first_tag_index == -1)
                    $first_tag_index = max(0, $i - 1);
            } else if (self::is_res_tag($lc)) {
                $this->other_res_tags[$lc] = 1;
                $this->tags['SD'] = $lc;
                if ($first_tag_index == -1)
                    $first_tag_index = max(0, $i - 1);
            } else if (isset(self::$KNOWN_OTHER_TAGS[$lc])) {
                $tag = self::$KNOWN_OTHER_TAGS[$lc];
                $this->tags[$tag] = $lc;
                if ($first_tag_index == -1)
                    $first_tag_index = max(0, $i - 1);
            } else if ($is_rpart && ($lc == 'bonus' || $lc == 'бонус')) {
                $this->bonus = true;
            } else if ($is_rpart && $left_empty &&
                isset(self::$RPART_IGNORE_MAP[$lc])) {
            } else if ($is_rpart && $left_empty &&
                isset(self::$RPART_IGNORE_MAP2[$lc]) &&
                $lc2 == self::$RPART_IGNORE_MAP2[$lc])
            {
                $arr[$i + 2] = '';
            } else if (!self::word_is_empty($lc)) {

                if (isset(self::$BAD_TAGS[$lc]))
                    $this->bad_tags[] = $lc;
                $del = false;
                $left_empty = false;
            }

            if ($del)
                $arr[$i] = '';
        }

        // Extracting additional content info.
        if (!$this->name_or_year_invalid && !$is_rpart) {
            $this->parse_add_content($arr);
        }

        self::normalize_seps($arr);

        // Extracting left bracket groups.
        if (!$is_rpart)
            $this->parse_brackets($arr);

        self::normalize_seps($arr);

        return self::join_parse_arr($arr, $first_tag_index);
    }

    // Joining or deleting (clearing) separators when needed; array
    // size unchanged.
    private static function normalize_seps(&$arr)
    {
        for ($i = 0; $i < 100; $i++) {
            $num_changes = self::normalize_seps_once($arr, $i);
            if ($num_changes == 0)
                break;
        }
        if ($i == 100)
            hd_print("INTERNAL ERROR: normalize_seps hangup for: $name");
    }
}

?>
